/* Tools.h
 *
 * Copyright (C) 2008 Laboratoire Statistique & Genome
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef TOOLS_H
#define TOOLS_H

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <fstream>
#include <string>
#include <iomanip>
#include <seqpp/SequenceSet.h>
#include <seqpp/Markov.h>
#include <sstream>

using namespace std;

double factorielle(int n);
double lnfactorielle(int n);
double comb(int n, int p);
double lncomb(int n, int p);
int compare(char * a, char * b);
int Multinomial_1_Draw ( int dim, double * param );
double amat(double t);
double bmat(double t);
void normalA(double *** A, int nbl, int nbc, double AMIN);
void normalB(double *** B, int nbl, int nbc, double BMIN, double BMAX);
void decompose(int u, int order, int size, int * tab);

#endif //TOOLS_H
