/* Word.h
 *
 * Copyright (C) 2008 Laboratoire Statistique & Genome
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef WORD_H
#define WORD_H

#include <Drifting_Markov.h>

using namespace std;

class Word
{
  
private:
  
  int _length;
  char* _word;
  Translator * _alphabet;

public:

  Word(const char * word, char *fa);
  virtual ~Word();  

  //Probability of Word at position t of a DMM
  double proba(unsigned long t, Drifting_Markov & DMM); 
 
  //Expectation of Word in a DMM of size n
  double expect(unsigned long n, Drifting_Markov & DMM);

  //Word length
  int length();

};


#endif //WORD_H
